{-# LANGUAGE DeriveAnyClass #-}
module Horizon.Spec.Types.GitSource (GitSource(MkGitSource), url, revision, subdir) where

import           Data.Kind                   (Type)
import           Dhall                       (FromDhall, Generic, ToDhall)
import           Horizon.Spec.Types.Repo     (Repo)
import           Horizon.Spec.Types.Revision (Revision)
import           Horizon.Spec.Types.Subdir   (Subdir)

type GitSource :: Type
data GitSource where
  MkGitSource :: { url :: Repo, revision :: Revision, subdir :: Maybe Subdir } -> GitSource
  deriving stock (Eq, Show, Generic)
  deriving anyclass (FromDhall, ToDhall)
