{-# LANGUAGE DeriveAnyClass #-}
module Horizon.Spec.Types.OverlayExportSettings (OverlayExportSettings(MkOverlayExportSettings), packagesDir, overlayFile, overlay) where

import           Data.Kind                      (Type)
import           Dhall                          (FromDhall, Generic, ToDhall)
import           Horizon.Spec.Types.Overlay     (Overlay)
import           Horizon.Spec.Types.OverlayFile (OverlayFile)
import           Horizon.Spec.Types.PackagesDir (PackagesDir)

type OverlayExportSettings :: Type
data OverlayExportSettings where
  MkOverlayExportSettings :: { packagesDir :: PackagesDir
                                , overlayFile :: OverlayFile
                                , overlay :: Overlay } -> OverlayExportSettings
  deriving stock (Show, Eq, Generic)
  deriving anyclass (FromDhall, ToDhall)
